/* Eigenmath by G. Weigt

	The starting point for a symbolic computation is in run.cpp

	Input is scanned in scan.cpp

	Expression evaluation is done in eval.cpp

	Output is formatted in display.cpp
*/

#include "defs.h"
#define BUFLEN 100000
static char buf[BUFLEN];
static nio_console csl;

int
main(int argc, char *argv[])
{
	int i;
	FILE *f;

    lcd_ingray();
    clrscr();
	nio_InitConsole(&csl, 53, 29, 0, 0, 0, 15);
    nio_DrawConsole(&csl);
	nio_printf(&csl, "Eigenmath by G. Weigt\r\n");
	
	for (i = 1; i < argc; i++) {
		f = fopen(argv[i], "r");
		if (f == NULL) {
			nio_printf(&csl,"cannot open %s\n", argv[i]);
			exit(1);
		}
		fread(buf, BUFLEN, 1, f);
		fclose(f);
		run(buf);
	}
	
	nio_printf(&csl,"int %d\n",sizeof(int));

	for (;;) {
		nio_printf(&csl,"> ");
		nio_fgets(buf, BUFLEN, &csl);
		if (strncmp(buf, "quit", 4) == 0) break;
		run(buf);
	}
	
	nio_CleanUp(&csl);
}

void
clear_term()
{
}

extern void eval_print(void);

void
eval_display(void)
{
	eval_print();
}

void
printstr(char *s)
{
	while (*s)
		printchar(*s++);
}

extern int test_flag;

#define OUTBUFLEN 10000
char out_buf[OUTBUFLEN + 1];
int out_count;

void
printchar(int c)
{
	if (test_flag && out_count < OUTBUFLEN)
		out_buf[out_count++] = c;
	nio_printf(&csl,"%c",c);
}

void
printchar_nowrap(int c)
{
	printchar(c);
}

void
eval_draw(void)
{
	push(symbol(NIL));
}

void
eval_sample(void)
{
}

//****************WTF C STD LIB******************
void qsort(void* base,size_t cnt,size_t siz,int(*comp)(const void*,const void*)){
      enum {MAXTOP=40};
      typedef struct {size_t l,r;} TNode,*PNode;

      PNode stack=(PNode)malloc(MAXTOP*sizeof(TNode)+siz*2),top=stack;
      void *x=&stack[MAXTOP],*t=(void *)((size_t)x+siz);
      size_t i,j;
     
      base=(void*)((size_t)base-siz);     
      top->l=1;top->r=cnt;
      while (top>=stack) {
            while (top->l<top->r) {
                  i=top->l;j=top->r;memcpy(x,(void*)((size_t)base+siz*((i+j)>>1)),siz);
                  while (i<=j) {
                        while (comp((void*)((size_t)base+i*siz),x)<0) ++i;
                        while (comp((void*)((size_t)base+j*siz),x)>0) --j;
                        if (i<=j) {
                                  memcpy(t,(void*)((size_t)base+i*siz),siz);
                                  memcpy((void*)((size_t)base+i*siz),(void*)((size_t)base+j*siz),siz);
                                  memcpy((void*)((size_t)base+j*siz),t,siz);
                                  ++i;--j;
                                  }
                        }
                  if (top->r-i<=j-top->l) {
                                          if (i<top->r) {
                                                        top[1].l=i;top[1].r=top->r;top->r=j;
                                                        ++top;
                                                        }
                                          else top->r=j;
                                          }
                  else {
                       if (top->l<j) {
                                     top[1].l=top->l;top[1].r=j;top->l=i;
                                     ++top;
                                     }
                       else top->l=i;
                       }
                  }
            --top;
            }
      free(stack);
}

